'use strict';

/* App Module */

var luticate = angular.module('luticate', [
    'ui.bootstrap',
    'ui.router',
    'luticateUtils',
    'luticateAuth',
    'LocalStorageModule',
    'dialogs.main',
    'ngSanitize',
    'ui.validate'
]);

luticate.config(['$stateProvider', '$urlRouterProvider', '$httpProvider',
    function($stateProvider, $urlRouterProvider, $httpProvider) {

        $stateProvider.state('login',{
            url:'/',
            templateUrl:'views/login.html',
            controller:'LoginController'
        });

        $stateProvider.state('home',{
            url:'/home',
            templateUrl:'views/home.html',
            controller:'HomeController'
        });

        $stateProvider.state('users',{
            url:'/users',
            templateUrl:'views/users.html',
            controller:'UsersController'
        });

        $stateProvider.state('groups',{
            url:'/groups',
            templateUrl:'views/groups.html',
            controller:'GroupsController'
        });

        $stateProvider.state('permissions',{
            url:'/permissions',
            templateUrl:'views/permissions.html',
            controller:'PermissionsController'
        });

        $urlRouterProvider.otherwise('/');

        $httpProvider.interceptors.push(['luticateAuthCache', '$injector', '$q',
            function (luticateAuthCache, $injector, $q) {
            return {
                'request': function (config) {
                    var token = luticateAuthCache.getToken();

                    if (token != null)
                        config.headers['X-Authorization'] = token;

                    return config;
                },
                'responseError': function(rejection) {
                    /*if (rejection.status == 401) {
                        luticateAuthCache.removeUser();
                        $injector.get('$state').transitionTo('login');
                    }*/
                    return $q.reject(rejection);
                }
            };
        }]);

    }])
    .run(['$rootScope', '$state',function ($rootScope, $state) {
        $rootScope.$on('$stateChangeError', function (e, curr, prev) {
            $state.go('login');
        });
    }]);