angular.module('luticate')
    .controller('UsersController', ['$scope', 'luticateAuthUsers',
        function($scope, luticateAuthUsers) {

            $scope.luTable = {
                columns: [
                    {
                        name: "Username",
                        width: 3,
                        getValue: function (item) {
                            return item.Username;
                        }
                    }, {
                        name: "Email",
                        width: 3,
                        getValue: function (item) {
                            return item.Email;
                        }
                    }, {
                        name: "Firstname",
                        width: 3,
                        getValue: function (item) {
                            return item.Firstname;
                        }
                    }, {
                        name: "Lastname",
                        width: 3,
                        getValue: function (item) {
                            return item.Lastname;
                        }
                    }
                ],

                permissions: {
                    add: 'LU_USER_ADD',
                    del: 'LU_USER_DEL',
                    edit: 'LU_USER_EDIT'
                },

                getLoadPagePromise: function (page, perPage, promise) {
                    return luticateAuthUsers.getAll({page: page, perPage: perPage}, promise);
                },

                getDelPromise: function (id, promise) {
                    return luticateAuthUsers.del({user_id: id}, promise);
                },

                getEditController: function () {
                    return "UserEdit";
                }
            };
    }]);
